
/**
  * Copyright (c) 2009, 2011 Alexander Churanov. All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  * 1. Redistributions of source code must retain the above copyright
  * notice, this list of conditions and the following disclaimer.
  *
  * 2. Redistributions in binary form must reproduce the above
  * copyright notice, this list of conditions and the following
  * disclaimer in the documentation and/or other materials provided
  * with the distribution.
  *
  * THIS SOFTWARE IS PROVIDED BY ALEXANDER CHURANOV ``AS IS'' AND ANY
  * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ALEXANDER CHURANOV BE
  * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
  * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
  * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  */

#include <exercisix.hh>
#include <vector>
#include <stdexcept>

using std::vector;

TEST( "one equals to one" )
{
  EXPECT( 1, ==, 1 );
}

TEST( "two is less than three" )
{
  EXPECT( 2, <, 3 );
}

TEST( "at() completes successfully if index is within bounds" )
{
  int source[] = { 1, 2, 3 };
  vector <int> v(source, source + 3);
  EXPECT_NO_EXCEPTIONS( v.at(1) );
}

TEST( "at() throws exception of type 'std::out_of_range' "
      "if index is out of bounds" )
{
  int source[] = { 1, 2, 3 };
  vector <int> v(source, source + 3);
  
  EXPECT_EXCEPTION( v.at(7), std::out_of_range);
}
